Automatically load a component.
-
Pilou thank you for your clearer picture that my writings.
Because of my English very bad, I think I lacked clarity.
I want a single cube by Sketchup file.
In Sketchup file, you can have a complete project with many dynamic components, but you have a single cube!
@kaas said:
Not sure. Maybe you already have an instance of the component present in your model? Its easy to find out by debugging. Add just one line in this loop:
No instance is present in my file.
To test the code, you can download the extension HERE.
@kaas said:
This code won't help you though if you want to have just 1 cube per scene. That would make the code more complex.
It's complicated to automatically remove a "cube", when there are 2?
@dan rathbun said:
My response is why use a hidden geometric construct to "protect" other components ?
I would instead use an AttributeDictionary.Thank you for this information, I must annalyser this "class" with attention.
With the methods provided by this class, is it possible to make a dynamic component unusable without the presence of the extension?
For example :
If someone shares one of my dynamic components with a user without my extension, it must be impossible to use these dynamic features!
I want to go at the end of my research, because my final interest is not only the security of my dynamic components.
Thank you for your support
David
-
So to paraphrase...
You want to have your cube component loaded into the model's definitions.
You want to have ONE instance of it placed in the model.
That instance should be 'masked' - e.g. assigned a special OFF layer, be hidden and be locked.
[Aside: You could also make it so tiny that if was hard to find !]All this is readily done.
My example test code, checks if the definition is loaded and if not it loads it.
If it id loaded and there is an instance there is nothing more to do, otherwise it adds the instance...
I agree with Dan...
All of the messing on so far could be achieved by more subtle and less complex means.
It probably needs a separate thread...
However, here's my outline.
Your plugin code loads DC components.
It's possible to give a DC component a function which stops it working if the function fails.
Your RB code could add a new function to the DC functions-code in the model, as it loads.
Thereby your RB makes your special DCs usable.
If a recipient of your DC does not have your licensed RB loading, then your DC does not work for them.
The absence of your extra DC function to validate your DC could also be triggered when a users license expires.
Here's an example of an extra DC function your RB could add...require('sketchup') if Sketchup.version.to_i <= 8 require('dynamiccomponents.rb') else require('su_dynamiccomponents.rb') end if defined?($dc_observers) ### Open SketchUp's Dynamic Component Functions (V1) class. ### BUT only if DC extension is active... class DCFunctionsV1 protected unless DCFunctionsV1.method_defined?(;tnt_checker) def tnt_checker() return true end protected;tnt_checker ### Usage; =tnt_checker() end end#class end#if
Your main RB adds this extra function.
Within each of your DCs you use the extra function to set up a reference etc.
Usage:=tnt_checker()
It returns true if the RB has added the function of false/or fails otherwise...Unfortunately even that could be circumvented by a Pro user editing the DCs attributes, BUT if your DC code is convoluted enough and it relies on the =tnt_checker() function's value being true to perform its later functions, then it at least makes the DC much more difficult to 'pirate'...
They could also write their own code RB snippet to set up that function and always return true ? -
@tntdavid said:
If someone shares one of my dynamic components with a user without my extension, it must be impossible to use these dynamic features!
There is no way to make it impossible.
If you must use a DC function try to use a refinement for Ruby 2.0+.
Code example withdrawn. A refinement will not work, because the DC code files would themselves need to use the refinement.- Modifying the DCFunctionsV1 class may not pass inspection by the Trimple Developer extension signing page.
-
@tig said:
You could also make it so tiny that if was hard to find !
Very good idea.
We can also hide the edges of a model?
@tig said:
My example test code, checks if the definition is loaded and if not it loads it.
If it id loaded and there is an instance there is nothing more to do, otherwise it adds the instance...You talk about this example?
@tig said:
if definition.valid?
 if instance.valid? ###[or perhaps || definition.instances[0] ???]
  ### You are already set to do the DC load...
 else
  ### You need to add an instance - perhaps it's been deleted by the user ???
  ### NOW you are set to do the DC load...
 end
else ### definition is NOT valid - it's been deleted - so the instance has too.
 ### You load the definition AND add the instance again - seems like the user has deleted both !
 ### NOW you are set to do the DC load...
end
@tig said:
I agree with Dan...
All of the messing on so far could be achieved by more subtle and less complex means.
It probably needs a separate thread...I do not doubt for a moment of your words.
As my specialty are dynamic components, create a protection directly into the models is much easier for me.
Although my protection is not foolproof, it will be very difficult to circumvent.
@dan rathbun said:
There is no way to make it impossible.
If you must use a DC function try to use a refinement for Ruby 2.0+.
Code example withdrawn. A refinement will not work, because the DC code files would themselves need to use the refinement.Thanks for these informations
-
Hello,
I still can not limit the number of cube to 1.
If someone can give me more information on writing code, I would be very recognize him.
Thank you
David
-
Think through the logic...
Here set out in words - not code...
If there is no loaded definition, either it's a fresh start or the user has managed to delete it from the model: therefore you load it - otherwise you have got it already and you go to the next step.
Next.
If there is no instance of that definition, either because it's a fresh start or the user has managed to delete it from the model: therefore you need to add it - otherwise you already have it and do nothing.
If there are multiple instances delete all but the first one.S'il n'y a pas de la definition chargée, soit il est un nouveau départ, ou l'utilisateur a réussi à le supprimer du modÚle: donc vous le chargez [load] - sinon vous l'avez, déjà vous allez à l'étape suivante.
Prochain.
S'il n'y a pas d'instance de cette definition, soit parce qu'il est un nouveau départ, ou l'utilisateur a réussi à le supprimer du modÚle: par conséquent, vous devez l'ajouter - sinon, vous l'avez déjà et ne rien faire ...
S'il y a plusieurs instances supprimer tout sauf la premiĂšre.### model = Sketchup.active_model definitions = model.definitions if definition = definitions['cube'] ### or whatever it's named ### do nothing as we already have it else ### we load it because it's missing definition = definitions.load(path_to_cube.skp) ### you need to work that out end #if ### now check instance exists if definition.instances.length == 1 ### we have it instance = definition.instances[0] elsif definition.instances.length > 1 ### somehow we have duplicates, erase all but the first one [0] definition.instances[1..-1].each{|i| i.erase! } instance = definition.instances[0] else ### there is NO instance so we add it instance = model.entities.add_instance(definition, ORIGIN) end #if ### ### Now change instance to have an OFF layer, hide it, lock it etc etc ### ALWAYS do this in case the user has messed with it... ###
[mod=:1961t99s]Fixed my stupid typo '
definition.instances[1..-1]**.each**{|i| i.erase! }
'[/mod:1961t99s] -
Thanks TIG,
I followed your method, which is very clear and detailed:
def self.methode1 path = Sketchup.find_support_file("cube.skp", "Plugins/TesteCube/Components/") model = Sketchup.active_model definitions = model.definitions component_definition = definitions.load(path) point = Geom;;Point3d.new(0, 0, 0) transformation = Geom;;Transformation.new(point) if definition = definitions['cube'] else definition = definitions.load(path_to_cube.skp) end if definition.instances.length == 1 instance = definition.instances[0] elsif definition.instances.length > 1 definition.instances[1..-1]{|i| i.erase! } instance = definition.instances[0] else instance = model.entities.add_instance(component_definition, transformation) status = instance.locked = true layers = model.layers new_layer = layers.add "cube" new_layer.visible = false instance.layer = new_layer instance.locked = true instance.hidden = true Sketchup.active_model.import(@@path_to_00) end
I get this error message at the launch of SketchUp:
@unknownuser said:
Error Loading File C:/Users/DAVID/AppData/Roaming/SketchUp/SketchUp 2015/SketchUp/Plugins/TesteCube/logic.rb
Error: #<SyntaxError: C:/Users/DAVID/AppData/Roaming/SketchUp/SketchUp 2015/SketchUp/Plugins/TesteCube/logic.rb:30: syntax error, unexpected { arg, expecting keyword_end
definition.instances[1..-1]{|i| i.erase! }^
C:/Users/DAVID/AppData/Roaming/SketchUp/SketchUp 2015/SketchUp/Plugins/TesteCube/logic.rb:30: syntax error, unexpected '}', expecting keyword_end
definition.instances[1..-1]{|i| i.erase! }^
C:/Users/DAVID/AppData/Roaming/SketchUp/SketchUp 2015/SketchUp/Plugins/TesteCube/logic.rb:102: syntax error, unexpected end-of-input, expecting keyword_end>
C:/Program Files/SketchUp/SketchUp 2015/Tools/extensions.rb:197:inrequire' C:/Program Files/SketchUp/SketchUp 2015/Tools/extensions.rb:197:in
load'
C:/Users/DAVID/AppData/Roaming/SketchUp/SketchUp 2015/SketchUp/Plugins/TesteCube.rb:28:inregister_extension' C:/Users/DAVID/AppData/Roaming/SketchUp/SketchUp 2015/SketchUp/Plugins/TesteCube.rb:28:in
module:TesteCube'
C:/Users/DAVID/AppData/Roaming/SketchUp/SketchUp 2015/SketchUp/Plugins/TesteCube.rb:18:in `<top (required)>'I made a mistake somewhere?
Thank you
-
Wonderful
If I delete this line of code:
elsif definition.instances.length > 1 definition.instances[1..-1]{|i| i.erase! } instance = definition.instances[0]
Your method works great TIG!
Do you know why the line of code that is intended to deleted "cube", does not?
Many thanks for your help.
David
-
Use:
definition.instances[1..-1].each {|i| i.erase! }
-
Also have a look at this section in the picture.
My suggestion is: add more
puts
statements into your code to quickly find the problems (yourself).Edit: where are you declaring
definition
anyway??
-
Sorry about the typo - substitute Dan's
.each{
correction.
I have edited the original post to suit !Also I used the reference '
definition
' BUT you then used 'component_definition
'
Please try to match such references when you are given 'generic' code...Why did you not follow my example more closely [except for the stupid typo!] ???
PS: @Kaas is actually wrong it IS
=
NOT==
because
if definition = definitions[...
With the=
test you are trying to set the reference 'definition
' to be pointing to something 'by name' indefinitions
- if that fails then you getnil
returned, so then theelse
part of the test runs...
A==
test is for 'equality' of two items, and not for testing if setting a reference works... -
I took note of all your comments.
This is not very important but the code, do not remove the "cube", if there is more than one.
elsif component_definition.instances.length> 1 Â Â Â Â Â Â Â Â component_definition.instances [1 .. -1] .each {| i | i.erase! } Â Â Â Â Â Â Â Â component_definition.instances instance = [0]
You know why?
Thank you
David
-
It's wrongly formed, reread what you have typed it does not make sense.
Try this...elsif component_definition.instances.length > 1 component_definition.instances[1..-1].each{|i| i.erase! } instance = component_definition.instances[0]
I am assuming that all of your references to the cube's definition now use 'component_definition' rather than 'definition' ?
You cannot copy / paste snippets of code in a different sequence and hope that it will somehow work.
The first part of your code is also carried over from your earlier version and does NOT do what I asked you to do.
It always loads the path, but you ought to check if the definition exists and then load it if not.
Try following my code more closely, and remove your earlier steps which pre-load the cube before checking if it's loaded ! -
@tig said:
...PS: @Kaas is actually wrong it IS
=
NOT==
because
if definition = definitions[...
With the=
test you are trying to set the reference 'definition
' to be pointing to something 'by name' indefinitions
- if that fails then you getnil
returned, so then theelse
part of the test runs...
A==
test is for 'equality' of two items, and not for testing if setting a reference works...Thanks TIG. Learned something here.
-
@tig said:
I am assuming that all of your references to the cube's definition now use 'component_definition' rather than 'definition' ?
I think yes :
def self.methode00 path = Sketchup.find_support_file("cube.skp", "Plugins/TesteCube/Components/") model = Sketchup.active_model definitions = model.definitions component_definition = definitions.load(path) point = Geom;;Point3d.new(0, 0, 0) transformation = Geom;;Transformation.new(point) if component_definition = definitions['cube'] else component_definition = definitions.load(path_to_cube.skp) end if component_definition.instances.length == 1 instance = component_definition.instances[0] elsif component_definition.instances.length > 1 component_definition.instances [1..-1] .each {| i | i.erase! } instance = component_definition.instances[0] else instance = model.entities.add_instance(component_definition, transformation) status = instance.locked = true layers = model.layers new_layer = layers.add "cube" new_layer.visible = false instance.layer = new_layer instance.locked = true instance.hidden = true end end
@tig said:
You cannot copy / paste snippets of code in a different sequence and hope that it will somehow work.
Sorry for silly mistakes, but i am just beginning to understand the logic of the ruby.
I'm a simple Carpenter by training, then learn the ruby is not easy for me.
I Thank You for your understanding and your indulgence.
David
-
The initial
component_definition = definitions.load(path)
is NOT needed.
remove it, and retry. -
@tig said:
The initial
component_definition = definitions.load(path)
is NOT needed.
remove it, and retry.If I delete this line, the cube is no longer imported.
Another area of research:
Is it possible to activate a tool SketchUp, with an icon from my toolbar?
I would like to activate the tool, "Interact with Dynamic Components" and the window of "Components Options".
How to change the value of an attribute of a dynamic component, by clicking on an icon?
Thank you in advance for your lights.
David
-
The reason it's not loading is that the
if...else...end
test fails because you have not edited it properly:
The line
component_definition = definitions.load(path_to_cube.skp)
should actually be
component_definition = definitions.load(path)
Of course you can do all of what you outline by setting up appropriate code.
e.g. if you have a selected DC instance then a button click could change an attribute and then refresh the DC, but all of this is complex - we already have enough issues getting the cube.skp loaded !
-
Do not be so pessimistic TIG, because thanks to you I made very big progress in Ruby.
Here is an example of evolution, thanks to the ruby script:
Notice that the "Control Panel", is the "Click-Window 3D" layer are imported along with the "Hung Windows".
Other advanced thanks to ruby, the "Control Panel" always positions façe the camera when you call.
I want to believe you that my requests are complicated, but I will not give up before trying.
You can at least guide me by giving me the methods to use?
And if you are generous as usual, a small sample code?
Thank you in advance.
David
-
Try this to open the Options dialog for the currently selected DC.
$dc_observers.get_latest_class.show_configure_dialog
Here are some other clues to update a DC after you change its attributes in Ruby...
With
dins
set to an array of DC instances...
dins.each{|di| $dc_observers.get_latest_class.redraw(din, false, false) if din && din.valid?}
Alternatively
dins.each{|sel| $dc_observers.get_latest_class.redraw_with_undo(din) if din && din.valid? }
DC attributes are normally attached to the DC instance's definition,although some are on the instance itself.
Assuming thatdin
is the DC instance...
dda = din.definition.attribute_dictionary("dynamic_attributes") ida = din.attribute_dictionary("dynamic_attributes")
To see these, when testing etc, use
dda.each_pair{|k, v| puts "#{k} = #{v}" }
and so on...To get a particular 'key' value use this format.
Note how 'built-in' attributes start with an _
puts dda["_name"]
To set a particular 'key' to a new value use this format.
First see original name...
puts dda["_name"] **dda["_name"]="Banane"** puts dda["_name"]
which should show the new name...BUT remember that you need to do a '
redraw
' - as explained above to see the changes and update the DC's Options etc.Also consider how attribute values are stored - as strings, with dimensions in inches etc...
Advertisement